/*
	$Id: CompoundImpl.java 172 2006-04-08 22:00:11Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import java.io.PrintWriter;

/**
   ѥɤμǤ
*/
public abstract class CompoundImpl implements Compound {

    /** "struct" ޤ "union" ޤ "eunm" */
    protected String label;

    /** ι¤Τޤ϶Τޤ󷿤̾ */
    protected String name;

    /** ѥɤĥݡͥȤΥå */
    protected Components components;

    /** descǤ */
    private Description desc;

    /** ɥȤ˵ܤ뤳η̾ */
    private String descType;

    /**
       ѥɤޤ

       @param gm 롼ץޥ͡
       @param label "struct" ޤ "union" ޤ "enum"
       @param elem structǤޤunionǤޤenum
       @param name name°
       @param descType ɥȤ˵ܤ뤳η̾
    */
    protected CompoundImpl(final GroupManager gm, final String label,
			   final Element elem, final String name,
			   final String descType) {
	this.label = label;
	this.name = name;
	this.descType = descType;

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
	NodeList nodes = c.getDirectChildrenByTagName(getTagName());
	components = getComponents(gm, descType, nodes);
    }

    /**
       ݡͥȤΥ̾ޤ

       @return ݡͥȤΥ̾
    */
    protected abstract String getTagName();

    /**
       ΡɥꥹȤ饳ݡͥȤΥåȤޤ

       @param gm 롼ץޥ͡
       @param descType ɥȤ˵ܤ뤳η̾
       @param nodes ݡͥȤΥΡɥꥹ
       @return ݡͥȤΥå
    */
    protected abstract Components getComponents(GroupManager gm,
						String descType,
						NodeList nodes);

    /**
       ɥȤ˵ܤ뤳η̾ޤ

       @return ɥȤ˵ܤ뤳η̾
    */
    public final String getDescType() {
	return descType;
    }

    /**
       Υѥɤ˽°륳ݡͥȤΥåȤޤ

       @return ݡͥȤΥå
    */
    public final Components getComponents() {
	return components;
    }

    /**
       HTML˽Ϥե̾ޤ

       @param m ̻ҥޥ͡
       @return ե̾
    */
    protected String getFieldName(final IDManager m) {
	return "<b>" + m.getString(descType) + "</b>";
    }

    /**
       HTMLξܺ٤˽Ϥե̾ޤ

       @return ե̾
    */
    protected String getFieldName() {
	return "<b>" + descType + "</b>";
    }

    /**
       TeXξܺ٤˽Ϥե̾ޤ

       @return ե̾
    */
    protected String getTexFieldName() {
	return descType;
    }

    public final void printCompoundSummary(final PrintWriter wr) {
	IDManager m = IDManager.getInstance();
	String fieldName = getFieldName(m);

	wr.println(""
+ "    <table width=\"100%\" cellspacing=\"0\" border=\"1\">\n"
+ "      <tr>\n"
+ "        <td colspan=\"2\"><font size=\"+1\">" + fieldName + "</font><br>\n"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "        </tr>\n"
+ "      <tr>\n");
	components.printSummary(wr);
	wr.println(""
+ "      </tr>\n"
+ "    </table><br>");
    }

    public final void printCompoundDetail(final PrintWriter wr) {
	String fieldName = getFieldName();

	wr.println(""
+ "<p><a name=\"" + descType + "\"></a>\n"
+ "<font size=\"+1\">" + fieldName + "</font></p>\n"
+ "<dl><dd>" + desc.getText() + "");
	components.printDetail(wr);
	wr.println(""
+ "</dd></dl>\n"
+ "<hr>");
    }

    public final void printTexCompoundDetail(final PrintWriter wr) {
	String fieldName = Tex.safe(getTexFieldName());

	wr.println("\\Sid{" + fieldName + "}");
	wr.println(desc.getTexText());

	components.printTexDetail(wr);
    }
}
