/*
	$Id: DefaultParameter.java 178 2006-04-28 15:29:16Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   Ǥ

   paramǤбޤ
*/
public class DefaultParameter extends Parameter {

    /** type° */
    private String type;

    /** name° */
    private String name;

    /** descǤ */
    private Description desc;

    /**
       ޤ

       @param elem parameter
    */
    public DefaultParameter(final Element elem) {
	type = elem.getAttribute("type");
	name = elem.getAttribute("name");

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       {@inheritDoc}
    */
    @Override public String getCode() {
	if (type.indexOf('#') != -1) {
	    return type.replaceFirst("#", name);
	} else {
	    return type + " " + name;
	}
    }

    /**
       {@inheritDoc}
    */
    @Override public String getName() {
	return name;
    }

    /**
       {@inheritDoc}
    */
    @Override public String getText() {
	String argName = "<i>" + name + "</i>";

	if (type.indexOf('#') != -1) {
	    return type.replaceFirst("#", argName);
	} else {
	    return type + "&nbsp;" + argName;
	}
    }

    /**
       {@inheritDoc}
    */
    @Override public String getTexText() {
	String argName = "\\Sarg{" + Tex.safe(name) + "}";
	String texType = Tex.safe(type);

	if (texType.indexOf('#') != -1) {
	    return texType.replaceFirst("#", argName);
	} else {
	    return texType + " " + argName;
	}
    }

    /**
       {@inheritDoc}
    */
    @Override public void printDetail(final PrintWriter wr) {
	wr.println(""
+ "<i>" + name + "</i> - " + desc.getText() + "<br>\n");
   }

    /**
       {@inheritDoc}
    */
    @Override public void printTexDetail(final PrintWriter wr) {
	String argName = "\\Sarg{" + Tex.safe(name) + "}";

	wr.println(""
+ "\\item[" + argName + "] " + desc.getTexText());
   }

}
